<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelAvailAllotment ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelAvailAllotment extends AbstractStructArrayBase
{
    /**
     * The Allotment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelAvailAllotment[]
     */
    public $Allotment;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelAvailAllotment
     * @uses ArrayOfJPSOAP_HotelAvailAllotment::setAllotment()
     * @param \StructType\JPSOAP_HotelAvailAllotment[] $allotment
     */
    public function __construct(array $allotment = array())
    {
        $this
            ->setAllotment($allotment);
    }
    /**
     * Get Allotment value
     * @return \StructType\JPSOAP_HotelAvailAllotment[]|null
     */
    public function getAllotment()
    {
        return $this->Allotment;
    }
    /**
     * Set Allotment value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelAvailAllotment[] $allotment
     * @return \ArrayType\ArrayOfJPSOAP_HotelAvailAllotment
     */
    public function setAllotment(array $allotment = array())
    {
        foreach ($allotment as $arrayOfJPSOAP_HotelAvailAllotmentAllotmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelAvailAllotmentAllotmentItem instanceof \StructType\JPSOAP_HotelAvailAllotment) {
                throw new \InvalidArgumentException(sprintf('The Allotment property can only contain items of \StructType\JPSOAP_HotelAvailAllotment, "%s" given', is_object($arrayOfJPSOAP_HotelAvailAllotmentAllotmentItem) ? get_class($arrayOfJPSOAP_HotelAvailAllotmentAllotmentItem) : gettype($arrayOfJPSOAP_HotelAvailAllotmentAllotmentItem)), __LINE__);
            }
        }
        $this->Allotment = $allotment;
        return $this;
    }
    /**
     * Add item to Allotment value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelAvailAllotment $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelAvailAllotment
     */
    public function addToAllotment(\StructType\JPSOAP_HotelAvailAllotment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelAvailAllotment) {
            throw new \InvalidArgumentException(sprintf('The Allotment property can only contain items of \StructType\JPSOAP_HotelAvailAllotment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Allotment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelAvailAllotment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelAvailAllotment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelAvailAllotment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelAvailAllotment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelAvailAllotment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Allotment
     */
    public function getAttributeName()
    {
        return 'Allotment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_HotelAvailAllotment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
